#include "OpenFileRespMsg.h"


void OpenFileRespMsg_serializePayload(NetMessage* this, char* buf)
{
   OpenFileRespMsg* thisCast = (OpenFileRespMsg*)this;

   size_t bufPos = 0;
   
   // result
   bufPos += Serialization_serializeInt(&buf[bufPos], thisCast->result);

   // fileHandleID
   bufPos += Serialization_serializeStrAlign4(&buf[bufPos], thisCast->fileHandleIDLen,
      thisCast->fileHandleID);
   
   // stripePattern
   bufPos += StripePattern_serialize(thisCast->pattern, &buf[bufPos]);
}

fhgfs_bool OpenFileRespMsg_deserializePayload(NetMessage* this, const char* buf, size_t bufLen)
{
   OpenFileRespMsg* thisCast = (OpenFileRespMsg*)this;

   size_t bufPos = 0;

   unsigned resultFieldLen;
   unsigned handleBufLen;
   unsigned patternBufLen;
   
   // result
   if(!Serialization_deserializeInt(&buf[bufPos], bufLen-bufPos, &thisCast->result,
      &resultFieldLen) )
      return fhgfs_false;

   bufPos += resultFieldLen;
   
   // fileHandleID
   if(!Serialization_deserializeStrAlign4(&buf[bufPos], bufLen-bufPos,
      &thisCast->fileHandleIDLen, &thisCast->fileHandleID, &handleBufLen) )
      return fhgfs_false;
   
   bufPos += handleBufLen;
      
   // stripePattern
   if(!StripePattern_deserializePatternPreprocess(&buf[bufPos], bufLen-bufPos,
      &thisCast->patternHeader, &thisCast->patternStart, &patternBufLen) )
      return fhgfs_false;
   
   bufPos += patternBufLen;

   return fhgfs_true;
}

unsigned OpenFileRespMsg_calcMessageLength(NetMessage* this)
{
   OpenFileRespMsg* thisCast = (OpenFileRespMsg*)this;

   return NETMSG_HEADER_LENGTH +
      Serialization_serialLenInt() + // result
      Serialization_serialLenStrAlign4(thisCast->fileHandleIDLen) +
      StripePattern_getSerialPatternLength(thisCast->pattern);
}


