#include "ReadLocalFileV2Msg.h"


void ReadLocalFileV2Msg_serializePayload(NetMessage* this, char* buf)
{
   ReadLocalFileV2Msg* thisCast = (ReadLocalFileV2Msg*)this;

   size_t bufPos = 0;
   
   // offset
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->offset);

   // count
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->count);

   // accessFlags
   bufPos += Serialization_serializeUInt(&buf[bufPos], thisCast->accessFlags);

   // fileHandleID
   bufPos += Serialization_serializeStrAlign4(&buf[bufPos], thisCast->fileHandleIDLen,
      thisCast->fileHandleID);

   // sessionID
   bufPos += Serialization_serializeStrAlign4(&buf[bufPos], thisCast->sessionIDLen,
      thisCast->sessionID);

   // targetID
   bufPos += Serialization_serializeUShort(&buf[bufPos], thisCast->targetID);

   // disableIO
   bufPos += Serialization_serializeBool(&buf[bufPos], thisCast->disableIO);
}

fhgfs_bool ReadLocalFileV2Msg_deserializePayload(NetMessage* this, const char* buf, size_t bufLen)
{
   ReadLocalFileV2Msg* thisCast = (ReadLocalFileV2Msg*)this;

   size_t bufPos = 0;

   unsigned offsetLen;
   unsigned countLen;
   unsigned accessFlagsLen;
   unsigned handleBufLen;
   unsigned targetBufLen;
   unsigned sessionBufLen;
   unsigned disableIOLen;
   
   // offset
   if(!Serialization_deserializeInt64(&buf[bufPos], bufLen-bufPos, &thisCast->offset, &offsetLen) )
      return fhgfs_false;
   
   bufPos += offsetLen;

   // count
   if(!Serialization_deserializeInt64(&buf[bufPos], bufLen-bufPos, &thisCast->count, &countLen) )
      return fhgfs_false;
   
   bufPos += countLen;

   // accessFlags
   if(!Serialization_deserializeUInt(&buf[bufPos], bufLen-bufPos, &thisCast->accessFlags,
      &accessFlagsLen) )
      return fhgfs_false;

   bufPos += accessFlagsLen;

   // fileHandleID
   if(!Serialization_deserializeStrAlign4(&buf[bufPos], bufLen-bufPos,
      &thisCast->fileHandleIDLen, &thisCast->fileHandleID, &handleBufLen) )
      return fhgfs_false;
   
   bufPos += handleBufLen;

   // sessionID
   if(!Serialization_deserializeStrAlign4(&buf[bufPos], bufLen-bufPos,
      &thisCast->sessionIDLen, &thisCast->sessionID, &sessionBufLen) )
      return fhgfs_false;
   
   bufPos += sessionBufLen;
   
   // targetID
   if(!Serialization_deserializeUShort(&buf[bufPos], bufLen-bufPos,
      &thisCast->targetID, &targetBufLen) )
      return fhgfs_false;

   bufPos += targetBufLen;

   // disableIO
   if(!Serialization_deserializeBool(&buf[bufPos], bufLen-bufPos, &thisCast->disableIO,
      &disableIOLen) )
      return fhgfs_false;

   bufPos += disableIOLen;

   return fhgfs_true;   
}

unsigned ReadLocalFileV2Msg_calcMessageLength(NetMessage* this)
{
   ReadLocalFileV2Msg* thisCast = (ReadLocalFileV2Msg*)this;

   return NETMSG_HEADER_LENGTH +
      Serialization_serialLenInt64() + // offset
      Serialization_serialLenInt64() + // count
      Serialization_serialLenUInt() + // accessFlags
      Serialization_serialLenStrAlign4(thisCast->fileHandleIDLen) +
      Serialization_serialLenStrAlign4(thisCast->sessionIDLen) +
      Serialization_serialLenUShort() + // targetID
      Serialization_serialLenBool(); // disableIO
}

