#include "WriteLocalFileMsg.h"


void WriteLocalFileMsg_serializePayload(NetMessage* this, char* buf)
{
   WriteLocalFileMsg* thisCast = (WriteLocalFileMsg*)this;

   size_t bufPos = 0;
   
   // offset
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->offset);

   // count
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->count);
   
   // accessFlags
   bufPos += Serialization_serializeUInt(&buf[bufPos], thisCast->accessFlags);

   if(NetMessage_isMsgHeaderFeatureFlagSet(this, WRITELOCALFILEMSG_FLAG_USE_QUOTA))
   {
      // userID
      bufPos += Serialization_serializeUInt(&buf[bufPos], thisCast->userID);

      // groupID
      bufPos += Serialization_serializeUInt(&buf[bufPos], thisCast->groupID);
   }

   // fileHandleID
   bufPos += Serialization_serializeStrAlign4(&buf[bufPos], thisCast->fileHandleIDLen,
      thisCast->fileHandleID);

   // sessionID
   bufPos += Serialization_serializeStrAlign4(&buf[bufPos], thisCast->sessionIDLen,
      thisCast->sessionID);

   // targetID
   bufPos += Serialization_serializeUShort(&buf[bufPos], thisCast->targetID);

   // mirrorToTargetID
   bufPos += Serialization_serializeUShort(&buf[bufPos], thisCast->mirrorToTargetID);

   // mirroredFromTargetID
   bufPos += Serialization_serializeUShort(&buf[bufPos], thisCast->mirroredFromTargetID);

   // disableIO
   bufPos += Serialization_serializeBool(&buf[bufPos], thisCast->disableIO);
}

unsigned WriteLocalFileMsg_calcMessageLength(NetMessage* this)
{
   WriteLocalFileMsg* thisCast = (WriteLocalFileMsg*)this;

   unsigned retVal = NETMSG_HEADER_LENGTH +
      Serialization_serialLenInt64() + // offset
      Serialization_serialLenInt64() + // count
      Serialization_serialLenUInt() + // accessFlags
      Serialization_serialLenStrAlign4(thisCast->fileHandleIDLen) +
      Serialization_serialLenStrAlign4(thisCast->sessionIDLen) +
      Serialization_serialLenUShort() + // targetID
      Serialization_serialLenUShort() + // mirrorToTargetID
      Serialization_serialLenUShort() + // mirroredFromTargetID
      Serialization_serialLenBool(); // disableIO

   if(NetMessage_isMsgHeaderFeatureFlagSet(this, WRITELOCALFILEMSG_FLAG_USE_QUOTA))
   {
      retVal += Serialization_serialLenUInt(); // userID
      retVal += Serialization_serialLenUInt(); // groupID
   }

   return retVal;
}


