#include "ListDirFromOffsetMsg.h"


void ListDirFromOffsetMsg_serializePayload(NetMessage* this, char* buf)
{
   ListDirFromOffsetMsg* thisCast = (ListDirFromOffsetMsg*)this;

   size_t bufPos = 0;
   
   // serverOffset
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->serverOffset);
   
   // incrementalOffset
   bufPos += Serialization_serializeUInt64(&buf[bufPos], thisCast->incrementalOffset);

   // maxOutNames
   bufPos += Serialization_serializeUInt(&buf[bufPos], thisCast->maxOutNames);

   // EntryInfo
   bufPos += EntryInfo_serialize(thisCast->entryInfoPtr, &buf[bufPos]);
}

unsigned ListDirFromOffsetMsg_calcMessageLength(NetMessage* this)
{
   ListDirFromOffsetMsg* thisCast = (ListDirFromOffsetMsg*)this;

   return NETMSG_HEADER_LENGTH +
      EntryInfo_serialLen(thisCast->entryInfoPtr) +
      Serialization_serialLenInt64() + // serverOffset
      Serialization_serialLenUInt64() + // incrementalOffset
      Serialization_serialLenUInt(); // maxOutNames
}


