#include "ListDirFromOffsetRespMsg.h"


void ListDirFromOffsetRespMsg_serializePayload(NetMessage* this, char* buf)
{
   ListDirFromOffsetRespMsg* thisCast = (ListDirFromOffsetRespMsg*)this;

   size_t bufPos = 0;
   
   // newServerOffset
   bufPos += Serialization_serializeInt64(&buf[bufPos], thisCast->newServerOffset);

   // result
   bufPos += Serialization_serializeInt(&buf[bufPos], thisCast->result);

   // entryTypes
   bufPos += Serialization_serializeIntCpyVec(&buf[bufPos], thisCast->entryTypes);

   // names
   bufPos += Serialization_serializeStrCpyVec(&buf[bufPos], thisCast->names);
}

fhgfs_bool ListDirFromOffsetRespMsg_deserializePayload(NetMessage* this, const char* buf,
   size_t bufLen)
{
   ListDirFromOffsetRespMsg* thisCast = (ListDirFromOffsetRespMsg*)this;

   size_t bufPos = 0;
   
   unsigned resultFieldLen;
   unsigned newServerOffsetBufLen;

   // newServerOffset
   if(!Serialization_deserializeInt64(&buf[bufPos], bufLen-bufPos,
      &thisCast->newServerOffset, &newServerOffsetBufLen) )
      return fhgfs_false;

   bufPos += newServerOffsetBufLen;

   // result
   if(!Serialization_deserializeInt(&buf[bufPos], bufLen-bufPos, &thisCast->result,
      &resultFieldLen) )
      return fhgfs_false;

   bufPos += resultFieldLen;
   
   // entryTypes
   if(!Serialization_deserializeIntCpyVecPreprocess(&buf[bufPos], bufLen-bufPos,
      &thisCast->entryTypesElemNum, &thisCast->entryTypesListStart, &thisCast->entryTypesBufLen) )
      return fhgfs_false;

   bufPos += thisCast->entryTypesBufLen;

   // names
   if(!Serialization_deserializeStrCpyVecPreprocess(&buf[bufPos], bufLen-bufPos,
      &thisCast->namesElemNum, &thisCast->namesListStart, &thisCast->namesBufLen) )
      return fhgfs_false;
      
   bufPos += thisCast->namesBufLen;


   return fhgfs_true;
}

unsigned ListDirFromOffsetRespMsg_calcMessageLength(NetMessage* this)
{
   ListDirFromOffsetRespMsg* thisCast = (ListDirFromOffsetRespMsg*)this;

   return NETMSG_HEADER_LENGTH +
      Serialization_serialLenInt() + // result
      Serialization_serialLenStrCpyVec(thisCast->names) +
      Serialization_serialLenIntCpyVec(thisCast->entryTypes) +
      Serialization_serialLenInt64(); // newServerOffset
}

