#ifndef OPEN_STRINGTK_H_
#define OPEN_STRINGTK_H_

#include <common/Common.h>
#include <common/toolkit/list/StrCpyList.h>


// manipulation
extern void StringTk_explode(const char* s, char delimiter, StrCpyList* outList);
extern char* StringTk_strncpyTerminated(char* dest, const char* src, size_t count);

// numerical
extern int StringTk_strToInt(const char* s);
extern unsigned StringTk_strToUInt(const char* s);
extern int64_t StringTk_strToInt64(const char* s);
extern uint64_t StringTk_strToUInt64(const char* s);
extern fhgfs_bool StringTk_strToBool(const char* s);

// construction
extern char* StringTk_strDup(const char* s);
extern char* StringTk_subStr(const char* start, unsigned numChars);
extern char* StringTk_trimCopy(const char* s);
extern char* StringTk_kasprintf(const char *fmt, ...);

extern char* StringTk_intToStr(int a);
extern char* StringTk_uintToStr(unsigned a);
extern char* StringTk_uintToHexStr(unsigned a);
extern char* StringTk_int64ToStr(int64_t a);
extern char* StringTk_uint64ToHexStr(uint64_t a);
extern char* StringTk_doubleToStr(double a);

// inliners
static inline fhgfs_bool StringTk_hasLength(const char* s);



fhgfs_bool StringTk_hasLength(const char* s)
{
   return s[0] ? fhgfs_true : fhgfs_false;
}


#endif /*OPEN_STRINGTK_H_*/
