#include <net/filesystem/RemotingIOInfo.h>
#include <common/storage/striping/StripePattern.h>

/**
 * Return the number of pages per stripe
 */
unsigned RemotingIOInfo_getNumPagesPerStripe(RemotingIOInfo* ioInfo)
{
   StripePattern* pattern = ioInfo->pattern;
   unsigned chunkSize = StripePattern_getChunkSize(pattern);
   UInt16Vec* targetIDs = pattern->getStripeTargetIDs(pattern);
   size_t numStripeNodes = UInt16Vec_length(targetIDs);

   unsigned stripeSize = chunkSize * numStripeNodes;

   return stripeSize / PAGE_SIZE;
}



